#pragma once
#include <cstdint>
#include <memory>
#include "collections.hpp"
#include "TickSystem.hpp"

class Sortiva final
{
public:
	Sortiva();
	~Sortiva();

	void run();
private:
	int m_Width;
	int m_Height;
	bool m_Running;


	void draw();
	void update(double deltatime);

	void setup();

	std::vector<TickSystem> m_TickSystems;

	//	std::unique_ptr
	//		-> tree 
	//			-> linked_list
	//				-> uint16_t
	using val_step_diag = std::vector<linked_list<uint16_t>>;
	std::unique_ptr<val_step_diag> m_Steps;
};
